/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_default_latency (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_pipe_model cached_pipe_model ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;
  int cached_length ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 98:  /* stack_adjust_ldr */
      return 3;

    case 111:  /* nop */
    case 97:  /* stack_adjust_str */
    case 94:  /* return_internal_interrupt */
    case 93:  /* return_i */
    case 88:  /* *tablejump_hi_internal */
    case 87:  /* *tablejump_internal */
    case 86:  /* indirect_jump */
    case 85:  /* jump */
    case 84:  /* *rev_branch_insn */
    case 83:  /* branch_insn */
    case 46:  /* *movcc_i */
    case 45:  /* gie */
    case 44:  /* gid */
      return 1;

    case 92:  /* *sibcall_value_i */
    case 91:  /* *call_value_i */
    case 90:  /* *sibcall_i */
    case 89:  /* *call_i */
    case 76:  /* *cmpsf_uneq */
    case 75:  /* *cmpsf_ord */
    case 74:  /* *cmpsf_gte */
    case 73:  /* *cmpsf_eq */
    case 43:  /* *umodsi3_2 */
    case 42:  /* *umodsi3_1 */
    case 41:  /* *modsi3_2 */
    case 40:  /* *modsi3_1 */
    case 39:  /* *udivsi3_2 */
    case 38:  /* *udivsi3_1 */
    case 37:  /* *divsi3_2 */
    case 36:  /* *divsi3_1 */
    case 23:  /* *recipsf2_2 */
    case 22:  /* *recipsf2_1 */
      return 8;

    case 110:  /* *fmaddv2sf_combine */
    case 109:  /* *fmaddv2si_combine */
    case 108:  /* mulv2sf3_i */
    case 107:  /* mulv2si3_i */
    case 106:  /* *ashlv2si3_i */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 72:  /* *cmpsf_cc_insn */
    case 35:  /* *imsub */
    case 34:  /* *maddsi_combine */
    case 33:  /* *imul */
    case 32:  /* *isub_i */
    case 31:  /* *iadd_i */
    case 30:  /* *fix_truncsfsi2_i */
    case 29:  /* *floatsisf2_cmp_i */
    case 28:  /* *floatsisf2_i */
    case 27:  /* *fmsub_combine */
    case 26:  /* *fmsub */
    case 25:  /* *maddsf_combine */
    case 24:  /* *fmadd */
    case 21:  /* *mulsf3_i */
    case 20:  /* *subsf3_f_i */
    case 19:  /* *subsf3_i */
    case 18:  /* *addsf3_i */
      return 5;

    case 16:  /* addsi3_r */
      return 4;

    case 13:  /* *movv8qi_insn */
    case 12:  /* *movv4hi_insn */
    case 11:  /* *movv2sf_insn */
    case 10:  /* *movv2si_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 2;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else if (which_alternative == 2)
        {
	  return 3;
        }
      else
        {
	  return 1;
        }

    case 6:  /* *movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return 2;
        }
      else if (which_alternative == 5)
        {
	  return 3;
        }
      else
        {
	  return 1;
        }

    case 14:  /* *movsf_insn */
    case 2:  /* *movhi_insn */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else if (which_alternative == 2)
        {
	  return 3;
        }
      else
        {
	  return 1;
        }

    case 1:  /* *movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 2;
        }
      else if (which_alternative == 3)
        {
	  return 3;
        }
      else
        {
	  return 1;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (((cached_pipe_model = get_attr_pipe_model (insn)) == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_MISC) || (cached_type == TYPE_MUL)) && ((cached_length = get_attr_length (insn)) == 4))
        {
	  return 2;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_MISC) || (cached_type == TYPE_MUL)) && ((cached_length = get_attr_length (insn)) == 8))
        {
	  return 2;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_MISC) || (cached_type == TYPE_MUL)) && (((cached_length = get_attr_length (insn)) == 12 /* 0xc */) || (cached_length == 16 /* 0x10 */) || (cached_length == 20 /* 0x14 */) || (cached_length == 24 /* 0x18 */)))
        {
	  return 4;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 3;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 1;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_BRANCH) || (cached_type == TYPE_UNCOND_BRANCH)))
        {
	  return 1;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_CALL) || (cached_type == TYPE_SFUNC) || (cached_type == TYPE_FP_SFUNC)))
        {
	  return 8;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && ((cached_type = get_attr_type (insn)) == TYPE_FLOW))
        {
	  return 1;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_FP) || (cached_type == TYPE_FP_INT)))
        {
	  return 5;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && ((cached_type = get_attr_type (insn)) == TYPE_V2FP))
        {
	  return 5;
        }
      else
        {
	  return 0;
        }

    default:
      return 2;

    }
}

